diff -ruN ../nakedmudv3.1/src/room_reset.c src/room_reset.c
--- ../nakedmudv3.1/src/room_reset.c	Sun Dec  4 20:03:08 2005
+++ src/room_reset.c	Sat Jul  1 20:06:58 2006
@@ -713,18 +713,31 @@
 
 //
 // room reset hook. Whenever a room is reset, apply all of its reset rules
-void room_reset_hook(ZONE_DATA *zone) {
+void room_reset_hook(const char *info) {
+  char  *zone_key = NULL;
+  hookParseInfo(info, &zone_key);
+  ZONE_DATA *zone = worldGetZone(gameworld, zone_key);
+  free(zone_key);
+
   LIST_ITERATOR *res_i = newListIterator(zoneGetResettable(zone));
   char           *name = NULL;
   const char   *locale = zoneGetKey(zone);
   RESET_LIST     *list = NULL;
   ROOM_DATA      *room = NULL;
   ITERATE_LIST(name, res_i) {
-    room = worldGetRoom(gameworld, get_fullkey(name, locale));
-    list = worldGetType(gameworld, "reset", get_fullkey(name, locale));
-    // do we have resets? If so, apply them...
-    if(room != NULL && list != NULL)
-      resetRunOn(resetListGetResets(list), room, INITIATOR_ROOM, locale);
+    if((room = worldGetRoom(gameworld, get_fullkey(name, locale))) != NULL) {
+      // first apply all of our prototype resets
+      LIST            *protos = parse_keywords(roomGetPrototypes(room));
+      LIST_ITERATOR  *proto_i = newListIterator(protos);
+      char             *proto = NULL;
+
+      // try to run each parent reset, and finally our own
+      ITERATE_LIST(proto, proto_i) {
+	if((list = worldGetType(gameworld, "reset", proto)) != NULL)
+	  resetRunOn(resetListGetResets(list), room, INITIATOR_ROOM, locale);
+      } deleteListIterator(proto_i);
+      deleteListWith(protos, free);
+    }
   } deleteListIterator(res_i);
 }
 
diff -ruN ../nakedmudv3.1/src/scripts/module.mk src/scripts/module.mk
--- ../nakedmudv3.1/src/scripts/module.mk	Sun Dec  4 20:18:43 2005
+++ src/scripts/module.mk	Sat Jul  1 20:12:13 2006
@@ -101,6 +101,8 @@
 	scripts/pychar.c        \
 	scripts/pyobj.c         \
 	scripts/pymud.c         \
+	scripts/pymudsys.c      \
+	scripts/pyhooks.c       \
 	scripts/pyroom.c        \
 	scripts/pyexit.c        \
 	scripts/script_editor.c \
diff -ruN ../nakedmudv3.1/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv3.1/src/scripts/pychar.c	Sun Dec  4 20:03:07 2005
+++ src/scripts/pychar.c	Sat Jul  1 20:06:58 2006
@@ -22,12 +22,14 @@
 #include "../action.h"
 #include "../socket.h"
 #include "../prototype.h"
+#include "../save.h"
 
 #include "pyplugs.h"
 #include "scripts.h"
 #include "pychar.h"
 #include "pyroom.h"
 #include "pyobj.h"
+#include "pyexit.h"
 #include "pyauxiliary.h"
 
 
@@ -132,6 +134,12 @@
   else           return NULL;
 }
 
+PyObject *PyChar_getlookbuf(PyChar *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL) return Py_BuildValue("s", bufferString(charGetLookBuffer(ch)));
+  else           return NULL;
+}  
+
 PyObject *PyChar_getrdesc(PyChar *self, void *closure) {
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
   if(ch != NULL) return Py_BuildValue("s", charGetRdesc(ch));
@@ -266,6 +274,31 @@
   return retval;
 }
 
+PyObject *PyChar_getbodyparts(PyChar *self, PyObject *args) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch == NULL) 
+    return NULL;
+
+  PyObject *list = PyList_New(0);
+  int i, num_bodyparts;
+  const char **bodyparts = bodyGetParts(charGetBody(ch), TRUE, &num_bodyparts);
+  for(i = 0; i < num_bodyparts; i++) {
+    PyObject *str = Py_BuildValue("s", bodyparts[i]);
+    PyList_Append(list, str);
+    Py_DECREF(str);
+  }
+  free(bodyparts);
+  return list;
+}
+
+
+PyObject *PyChar_getusergroups(PyChar *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL) 
+    return Py_BuildValue("s", bitvectorGetBits(charGetUserGroups(ch)));
+  else           
+    return NULL;
+}
 
 //
 // Standard check to make sure the character exists when
@@ -348,6 +381,24 @@
   return 0;
 }
 
+int PyChar_setlookbuf(PyChar *self, PyObject *value, void *closure) {
+  if (value == NULL) {
+    PyErr_Format(PyExc_TypeError, "Cannot delete character's look buffer");
+    return -1;
+  }
+  
+  if (!PyString_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "Look bufers must be strings");
+    return -1;
+  }
+
+  CHAR_DATA *ch;
+  PYCHAR_CHECK_CHAR_EXISTS(self->uid, ch);
+  bufferClear(charGetLookBuffer(ch));
+  bufferCat(charGetLookBuffer(ch), PyString_AsString(value));
+  return 0;
+}
+
 int PyChar_setrdesc(PyChar *self, PyObject *value, void *closure) {
   if (value == NULL) {
     PyErr_Format(PyExc_TypeError, "Cannot delete character's rdesc");
@@ -619,8 +670,9 @@
 //
 // make the character perform an action
 PyObject *PyChar_act(PyChar *self, PyObject *value) {
-  char *act          = NULL;
-  if (!PyArg_ParseTuple(value, "s", &act)) {
+  char     *act = NULL;
+  bool alias_ok = FALSE; 
+  if (!PyArg_ParseTuple(value, "s|b", &act, &alias_ok)) {
     PyErr_Format(PyExc_TypeError, "Characters actions must be strings.");
     return NULL;
   }
@@ -629,7 +681,7 @@
   if(ch) {
     // do not send the actual act - if we edit it, things go awry
     char *working_act = strdupsafe(act);
-    do_cmd(ch, working_act, FALSE);
+    do_cmd(ch, working_act, alias_ok);
     free(working_act);
     return Py_BuildValue("i", 1);
   }
@@ -648,7 +700,7 @@
   PyObject *py_tgt = NULL;
 
   if(!PyArg_ParseTuple(arg, "O", &py_tgt)) {
-    PyErr_Format(PyExc_TypeError, "Must supply obj or mob for cansee");
+    PyErr_Format(PyExc_TypeError, "Must supply obj, mob, or exit for cansee");
     return NULL;
   }
 
@@ -661,13 +713,16 @@
   else {
     OBJ_DATA    *obj = NULL;
     CHAR_DATA  *pers = NULL;
+    EXIT_DATA    *ex = NULL;
 
     if(PyChar_Check(py_tgt))
       pers = PyChar_AsChar(py_tgt);
     else if(PyObj_Check(py_tgt))
       obj  = PyObj_AsObj(py_tgt);
+    else if(PyExit_Check(py_tgt))
+      ex   = PyExit_AsExit(py_tgt);
     else {
-      PyErr_Format(PyExc_TypeError, "Must supply obj or mob to cansee");
+      PyErr_Format(PyExc_TypeError, "Must supply obj, mob, or exit to cansee");
       return NULL;
     }
 
@@ -675,6 +730,8 @@
       return Py_BuildValue("b", can_see_obj(ch, obj));
     else if(pers != NULL)
       return Py_BuildValue("b", can_see_char(ch, pers));
+    else if(ex != NULL)
+      return Py_BuildValue("b", can_see_exit(ch, ex));
     else {
       PyErr_Format(PyExc_StandardError, "Target of cansee did not exist!");
       return NULL;
@@ -810,7 +867,7 @@
   ROOM_DATA    *old_room = NULL;
   OBJ_DATA     *old_cont = NULL;
 
-  if (!PyArg_ParseTuple(args, "O|s", &pobj, &pos)) {
+  if (!PyArg_ParseTuple(args, "O|z", &pobj, &pos)) {
     PyErr_Format(PyExc_TypeError, 
 		 "Character equip must be supplied with an item to equip!");
     return NULL;
@@ -858,9 +915,10 @@
       obj_to_char(obj, old_carrier);
     else if(old_wearer != NULL)
       try_equip(ch, obj, old_pos, NULL);
-    PyErr_Format(PyExc_StandardError,
-		 "Character is already equipped in all possible positions!");
-    return NULL;
+    return Py_BuildValue("i", 0);
+    //    PyErr_Format(PyExc_StandardError,
+    //		 "Character is already equipped in all possible positions!");
+    //    return NULL;
   }
   // success
   else 
@@ -868,6 +926,28 @@
 }
 
 
+PyObject *PyChar_getequip(PyChar *self, PyObject *args) {  
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  OBJ_DATA *obj = NULL;
+  char     *pos = NULL;
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError, "Nonexistant character");
+    return NULL;
+  }
+
+  if(!PyArg_ParseTuple(args, "s", &pos)) {
+    PyErr_Format(PyExc_TypeError, "A position name must be supplied.");
+    return NULL;
+  }
+  
+  obj = bodyGetEquipment(charGetBody(ch), pos);
+  if(obj == NULL)
+    return Py_None;
+  else
+    return Py_BuildValue("O", objGetPyFormBorrowed(obj));
+}
+
+
 PyObject *PyChar_attach(PyChar *self, PyObject *args) {  
   char *key = NULL;
 
@@ -1074,7 +1154,7 @@
     data = Py_None;
   }
   PyObject *retval = Py_BuildValue("O", data);
-  Py_DECREF(data);
+  //  Py_DECREF(data);
   return retval;
 }
 
@@ -1102,6 +1182,28 @@
   }
 }
 
+//
+// returns whether or not the character belongs to one of the specified groups
+PyObject *PyChar_is_in_groups(PyChar *self, PyObject *args) {  
+  char *groups = NULL;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "s", &groups)) {
+    PyErr_Format(PyExc_TypeError, "is_in_groups only accepts strings.");
+    return NULL;
+  }
+
+  // pull out the object and check the type
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL)
+    return Py_BuildValue("i", bitIsSet(charGetUserGroups(ch), groups));
+  else {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to check user groups of nonexistent char, %d.", self->uid);
+    return NULL;
+  }
+}
+
 
 
 //*****************************************************************************
@@ -1442,12 +1544,16 @@
 		      "returns a list of objects in the char's inventory");
   PyChar_addGetSetter("eq",   PyChar_geteq,  NULL,
 		      "returns a list of the character's equipment");
+  PyChar_addGetSetter("bodyparts", PyChar_getbodyparts, NULL,
+		      "Returns a list of the character's bodyparts");
   PyChar_addGetSetter("name", PyChar_getname, PyChar_setname,
 		      "handle the character's name");
   PyChar_addGetSetter("mname", PyChar_getmname, PyChar_setmname,
 		      "handle the character's multi-name");
   PyChar_addGetSetter("desc", PyChar_getdesc, PyChar_setdesc,
 		      "handle the character's description");
+  PyChar_addGetSetter("look_buf", PyChar_getlookbuf, PyChar_setlookbuf,
+		      "handle the character's look buffer");
   PyChar_addGetSetter("rdesc", PyChar_getrdesc, PyChar_setrdesc,
 		      "handle the character's room description");
   PyChar_addGetSetter("mdesc", PyChar_getmdesc, PyChar_setmdesc,
@@ -1483,12 +1589,14 @@
   PyChar_addGetSetter("hisher", PyChar_gethisher, NULL,
 		      "Returns 'his' if the char is male, 'her' if female, and "
 		      "'its' for neuters");
-  PyChar_addGetSetter("himher", PyChar_gethisher, NULL,
+  PyChar_addGetSetter("himher", PyChar_gethimher, NULL,
 		      "Returns 'him' if the char is male, 'her' if female, and "
 		      "'it' for neuters");
-  PyChar_addGetSetter("heshe", PyChar_gethisher, NULL,
+  PyChar_addGetSetter("heshe", PyChar_getheshe, NULL,
 		      "Returns 'he' if the char is male, 'she' if female, and "
 		      "'it' for neuters");
+  PyChar_addGetSetter("user_groups", PyChar_getusergroups, NULL,
+		      "Returns the character's user groups");
 
   // add in all of our methods for the Char class
   PyChar_addMethod("attach", PyChar_attach, METH_VARARGS,
@@ -1514,6 +1622,8 @@
   PyChar_addMethod("equip", PyChar_equip, METH_VARARGS,
 		   "equips a character with the given item. Removes the item "
 		   "from whatever it is currently in/on.");
+  PyChar_addMethod("get_equip", PyChar_getequip, METH_VARARGS,
+		   "Returns the person's equipment in the specified slot.");
   PyChar_addMethod("isActing", PyChar_is_acting, METH_VARARGS,
 		   "Returns True if the character is currently taking an "
 		   "action, and False otherwise.");
@@ -1529,6 +1639,8 @@
 		   "page a bunch of text to the character.");
   PyChar_addMethod("isinstance", PyChar_isinstance, METH_VARARGS,
 		   "returns whether or not the char inherits from the proto");
+  PyChar_addMethod("isInGroup", PyChar_is_in_groups, METH_VARARGS,
+		   "returns whether or not the character belongs to one of the groups");
 
   // add in all the getsetters and methods
   makePyType(&PyChar_Type, pychar_getsetters, pychar_methods);
diff -ruN ../nakedmudv3.1/src/scripts/pyhooks.c src/scripts/pyhooks.c
--- ../nakedmudv3.1/src/scripts/pyhooks.c	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyhooks.c	Sat Jul  1 20:06:58 2006
@@ -0,0 +1,336 @@
+//*****************************************************************************
+//
+// pyhooks.c
+//
+// The wrapper around hooks for Python to interact with them.
+//
+//*****************************************************************************
+
+#include "../mud.h"
+#include "../utils.h"
+#include "../hooks.h"
+
+#include "scripts.h"
+#include "pyroom.h"
+#include "pychar.h"
+#include "pyobj.h"
+#include "pyexit.h"
+#include "pyplugs.h"
+#include "pyhooks.h"
+
+
+
+//*****************************************************************************
+// local variables and functions
+//*****************************************************************************
+
+// a list of methods to add to the hooks module
+LIST *pyhooks_methods = NULL;
+
+// a table of python hooks we have installed
+HASHTABLE *pyhook_table = NULL;
+
+
+
+//*****************************************************************************
+// local methods
+//*****************************************************************************
+PyObject *PyHooks_BuildInfo(PyObject *self, PyObject *args) {
+  // parse out our variables
+  char           *format = NULL;
+  PyObject         *vars = NULL;
+  if(!PyArg_ParseTuple(args, "sO", &format, &vars)) {
+    PyErr_Format(PyExc_TypeError,"PyHook_BuildInfo requies format and tuple.");
+    return NULL;
+  }
+
+  // make sure we have a tuple
+  if(!PyTuple_Check(vars)) {
+    PyErr_Format(PyExc_TypeError, "Second argument to PyHooks_buildInfo must "
+		 "be a tuple.");
+    return NULL;
+  }
+
+  LIST *tokens = parse_strings(format, ' ');
+  // make sure our tuple and tokens are of the same length
+  if(listSize(tokens) != PyTuple_Size(vars)) {
+    PyErr_Format(PyExc_TypeError, "unequal number of tokens and values.");
+    deleteListWith(tokens, free);
+    return NULL;
+  }
+
+  // build each of our tokens into the info
+  BUFFER            *buf = newBuffer(1);
+  LIST_ITERATOR *token_i = newListIterator(tokens);
+  char            *token = NULL;
+  int                  i = 0;
+  PyObject          *var = NULL;
+  ITERATE_LIST(token, token_i) {
+    if(!strcasecmp(token, "ch")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PyChar_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not Char", i);
+	break;
+      }
+      bprintf(buf, "ch.%d", PyChar_AsUid(var));
+    }
+    else if(!strcasecmp(token, "obj")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PyObj_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not Obj", i);
+	break;
+      }
+      bprintf(buf, "obj.%d", PyObj_AsUid(var));
+    }
+    else if(!strcasecmp(token, "rm") || !strcasecmp(token, "room")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PyRoom_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not Room", i);
+	break;
+      }
+      bprintf(buf, "rm.%d", PyRoom_AsUid(var));
+    }
+    else if(!strcasecmp(token, "ex") || !strcasecmp(token, "exit")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PyExit_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not Exit", i);
+	break;
+      }
+      bprintf(buf, "ex.%d", PyExit_AsUid(var));
+    }
+    else if(!strcasecmp(token, "str")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PyString_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not String", i);
+	break;
+      }
+      bprintf(buf, "%c%s%c", HOOK_STR_MARKER, PyString_AsString(var),
+	      HOOK_STR_MARKER);
+    }
+    else if(!strcasecmp(token, "int")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PyInt_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not Integer", i);
+	break;
+      }
+      bprintf(buf, "%ld", PyInt_AsLong(var));
+    }
+    else if(!strcasecmp(token, "dbl")) {
+      var = PyTuple_GetItem(vars, i);
+      if(!PyFloat_Check(var)) {
+	PyErr_Format(PyExc_TypeError, "arg %d was not Float", i);
+	break;
+      }
+      bprintf(buf, "%lf", PyFloat_AsDouble(var));
+    }
+
+    // put a space in for our next variable if needed
+    if(i < listSize(tokens) - 1)
+      bprintf(buf, " ");
+    i++;
+  } deleteListIterator(token_i);
+  deleteListWith(tokens, free);
+
+  // did we manage to go through all of our tokens or not?
+  if(i != PyTuple_Size(vars)) {
+    deleteBuffer(buf);
+    return NULL;
+  }
+  else {
+    PyObject *retval = Py_BuildValue("s", bufferString(buf));
+    deleteBuffer(buf);
+    return retval;
+  }
+}
+
+
+PyObject *PyHooks_ParseInfo(PyObject *self, PyObject *args) {
+  // parse out our info
+  char             *info = NULL;
+  if(!PyArg_ParseTuple(args, "s", &info)) {
+    PyErr_Format(PyExc_TypeError, "PyHook_ParseInfo must be supplied a string");
+    return NULL;
+  }
+
+  // parse out all of our tokens
+  LIST           *tokens = parse_hook_info_tokens(info);
+  LIST_ITERATOR *token_i = newListIterator(tokens);
+  char            *token = NULL;
+  PyObject         *list = PyTuple_New(listSize(tokens));
+  int                  i = 0;
+
+  // id number we'll need for parsing some values
+  int id = 0;
+
+  // we need to crash-proof this function still
+  //***********
+  // FINISH ME
+  //***********
+
+  // go through all of our tokens
+  ITERATE_LIST(token, token_i) {
+    if(startswith(token, "ch")) {
+      sscanf(token, "ch.%d", &id);
+      PyTuple_SetItem(list, i, charGetPyForm(propertyTableGet(mob_table,id)));
+    }
+    else if(startswith(token, "obj")) {
+      sscanf(token, "obj.%d", &id);
+      PyTuple_SetItem(list, i, objGetPyForm(propertyTableGet(obj_table,id)));
+    }
+    else if(startswith(token, "rm")) {
+      sscanf(token, "rm.%d", &id);
+      PyTuple_SetItem(list, i, roomGetPyForm(propertyTableGet(room_table,id)));
+    }
+    else if(startswith(token, "room")) {
+      sscanf(token, "room.%d", &id);
+      PyTuple_SetItem(list, i, roomGetPyForm(propertyTableGet(room_table,id)));
+    }
+    else if(startswith(token, "ex")) {
+      sscanf(token, "ex.%d", &id);
+      PyTuple_SetItem(list, i, newPyExit(propertyTableGet(exit_table, id)));
+    }
+    else if(startswith(token, "exit")) {
+      sscanf(token, "exit.%d", &id);
+      PyTuple_SetItem(list,i, newPyExit(propertyTableGet(exit_table, id)));
+    }
+    else if(*token == HOOK_STR_MARKER) {
+      char *str = strdup(token + 1);
+      str[strlen(str)-1] = '\0';
+      PyTuple_SetItem(list,i, Py_BuildValue("s", str));
+      free(str);
+    }
+    else if(isdigit(*token)) {
+      // integer or double?
+      if(next_letter_in(token, '.') > -1)
+	PyTuple_SetItem(list, i, Py_BuildValue("d", atof(token)));
+      else
+	PyTuple_SetItem(list,i, Py_BuildValue("i", atoi(token)));
+    }
+    i++;
+  } deleteListIterator(token_i);
+  deleteListWith(tokens, free);
+
+  return list;
+}
+
+
+PyObject *PyHooks_Run(PyObject *self, PyObject *args) {
+  char *type = NULL;
+  char *info = NULL;
+  if(!PyArg_ParseTuple(args, "ss", &type, &info)) {
+    PyErr_Format(PyExc_TypeError, "A string type and info must be supplied");
+    return NULL;
+  }
+
+  // run the hook
+  hookRun(type, info);
+  return Py_BuildValue("i", 1);
+}
+
+
+PyObject *PyHooks_Add(PyObject *self, PyObject *args) {
+  char     *type = NULL;
+  PyObject *hook = NULL;
+  if(!PyArg_ParseTuple(args, "sO", &type, &hook)) {
+    PyErr_Format(PyExc_TypeError, "Must supply with a type and function");
+    return NULL;
+  }
+
+  if(!PyFunction_Check(hook)) {
+    PyErr_Format(PyExc_TypeError, "Only functions may be supplied as hooks.");
+    return NULL;
+  }
+
+  Py_INCREF(hook);
+  LIST *list = hashGet(pyhook_table, type);
+  if(list == NULL) {
+    list = newList();
+    hashPut(pyhook_table, type, list);
+  }
+  listQueue(list, hook);  
+  return Py_BuildValue("i", 1);
+}
+
+
+PyObject *PyHooks_Remove(PyObject *self, PyObject *args) {
+  char     *type = NULL;
+  PyObject *hook = NULL;
+  if(!PyArg_ParseTuple(args, "sO", &type, &hook)) {
+    PyErr_Format(PyExc_TypeError, "Must supply with a type and function");
+    return NULL;
+  }
+
+  LIST *list = hashGet(pyhook_table, type);
+  if(list != NULL && listRemove(list, hook)) {
+    Py_DECREF(hook);
+  }
+  return Py_BuildValue("i", 1);
+}
+
+
+//
+// monitors hook activity, and handles the ones on the Python end
+void PyHooks_Monitor(const char *type, const char *info) {
+  LIST *list = hashGet(pyhook_table, type);
+  if(list != NULL) {
+    char *info_dup = strdup(info);
+    LIST_ITERATOR *list_i = newListIterator(list);
+    PyObject *func = NULL;
+    ITERATE_LIST(func, list_i) {
+      PyObject *arglist = Py_BuildValue("(s)", info);
+      PyObject *retval  = PyEval_CallObject(func, arglist);
+      // check for an error:
+      if(retval == NULL) {
+	char *tb = getPythonTraceback();
+	if(tb != NULL) {
+	  log_string("Error running python hook:\r\n%s\r\n", tb);
+	  free(tb);
+	}
+      }
+
+      // garbage collection
+      Py_XDECREF(retval);
+      Py_XDECREF(arglist);
+    } deleteListIterator(list_i);
+    free(info_dup);
+  }
+}
+
+
+
+//*****************************************************************************
+// Hooks module
+//*****************************************************************************
+PyMODINIT_FUNC
+init_PyHooks(void) {
+  PyHooks_addMethod("parse_info", PyHooks_ParseInfo, METH_VARARGS,
+		    "parses a hook info string into a tuple.");
+  PyHooks_addMethod("build_info", PyHooks_BuildInfo, METH_VARARGS,
+		    "builds a hook info string out of a tuple and format.");
+  PyHooks_addMethod("run", PyHooks_Run, METH_VARARGS,
+		    "runs a hook.");
+  PyHooks_addMethod("add", PyHooks_Add, METH_VARARGS,
+		    "adds a hook.");
+  PyHooks_addMethod("remove", PyHooks_Remove, METH_VARARGS,
+		    "removes a hook");
+
+  Py_InitModule3("hooks", makePyMethods(pyhooks_methods),
+		 "The hooks module.");
+
+  // set up our hook monitor
+  pyhook_table = newHashtable();
+  hookAddMonitor(PyHooks_Monitor);
+}
+
+void PyHooks_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pyhooks_methods == NULL) pyhooks_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pyhooks_methods, def);
+}
diff -ruN ../nakedmudv3.1/src/scripts/pyhooks.h src/scripts/pyhooks.h
--- ../nakedmudv3.1/src/scripts/pyhooks.h	Wed Dec 31 17:00:00 1969
+++ src/scripts/pyhooks.h	Sat Jul  1 20:06:58 2006
@@ -0,0 +1,23 @@
+#ifndef PYHOOKS_H
+#define PYHOOKS_H
+//*****************************************************************************
+//
+// pyhooks.h
+//
+// The wrapper around hooks for Python to interact with them.
+//
+//*****************************************************************************
+
+/* initialize mud module for use */
+PyMODINIT_FUNC
+init_PyHooks(void);
+
+//
+// Adds a new method function (i.e. void *f) to the hooks module. Name is the 
+// name of the function, f is the PyCFunction implementing the new method, 
+// flags is the type of method beings used (almost always METH_VARARGS), and 
+// doc is an (optional) description of what the method does. For examples on 
+// how to add new methods, see pyhooks.c
+void PyHooks_addMethod(const char *name, void *f, int flags, const char *doc);
+
+#endif // PYHOOKS_H
diff -ruN ../nakedmudv3.1/src/scripts/pymud.c src/scripts/pymud.c
--- ../nakedmudv3.1/src/scripts/pymud.c	Sun Dec  4 20:03:07 2005
+++ src/scripts/pymud.c	Sat Jul  1 20:06:58 2006
@@ -19,12 +19,14 @@
 #include "../character.h"
 #include "../inform.h"
 #include "../handler.h"
+#include "../parse.h"
 
 #include "scripts.h"
 #include "pyroom.h"
 #include "pychar.h"
 #include "pyobj.h"
 #include "pyplugs.h"
+#include "pyexit.h"
 
 
 
@@ -37,6 +39,9 @@
 // a list of methods to add to the mud module
 LIST *pymud_methods = NULL;
 
+// a placeholder of the movement command, as set by one of our modules
+PyObject *py_cmd_move = NULL;
+
 
 
 //*****************************************************************************
@@ -98,42 +103,6 @@
 
 
 //
-// add a new command to the mud, via a python script or module. Takes in a
-// command name, a sort_by command, the function, a minimum and maximum 
-// position in the form of strings, a level, and boolean values for whether the
-// command can be performed by mobiles, and whether it interrupts actions.
-PyObject *mud_add_cmd(PyObject *self, PyObject *args) {
-  PyObject *func = NULL;
-  char *name  = NULL, *sort_by = NULL, *min_pos = NULL, *max_pos = NULL,
-       *group = NULL;
-  bool mob_ok = FALSE, interrupts = FALSE;
-  int min_pos_num, max_pos_num;
-
-  // parse all of the values
-  if (!PyArg_ParseTuple(args, "szOsssbb", &name, &sort_by, &func,
-  			&min_pos, &max_pos, &group, &mob_ok, &interrupts)) {
-    PyErr_Format(PyExc_TypeError, 
-		 "Could not add new command. Improper arguments supplied");
-    return NULL;
-  }
-
-  // get our positions
-  min_pos_num = posGetNum(min_pos);
-  max_pos_num = posGetNum(max_pos);
-  if(min_pos_num == POS_NONE || max_pos_num == POS_NONE) {
-    PyErr_Format(PyExc_TypeError, 
-		 "Could not add new command. Invalid position names.");
-    return NULL;
-  }
-
-  // add the command to the game
-  add_py_cmd(name, sort_by, func, min_pos_num, max_pos_num,
-	     group, mob_ok, interrupts);
-  return Py_None;
-}
-
-
-//
 // format a string to be into a typical description style
 PyObject *mud_format_string(PyObject *self, PyObject *args) {
   char *string = NULL;
@@ -154,6 +123,42 @@
   return ret;
 }
 
+
+//
+// parses arguments for character commands
+PyObject *mud_parse_args(PyObject *self, PyObject *args) {
+  PyObject   *pych = NULL;
+  bool show_errors = FALSE;
+  char        *cmd = NULL;
+  char     *pyargs = NULL;
+  char     *syntax = NULL;
+  char *parse_args = NULL;
+  CHAR_DATA    *ch = NULL;
+
+  // parse our arguments
+  if(!PyArg_ParseTuple(args, "Obsss", &pych, &show_errors, 
+		       &cmd, &pyargs, &syntax)) {
+    PyErr_Format(PyExc_TypeError, "Invalid arguments to parse_args");
+    return NULL;
+  }
+
+  // convert the character
+  if(!PyChar_Check(pych) || (ch = PyChar_AsChar(pych)) == NULL) {
+      PyErr_Format(PyExc_TypeError, 
+		   "First argument must be an existent character!");
+      return NULL;
+  }
+
+  // strdup our py args; they might be edited in the parse function
+  parse_args = strdup(pyargs);
+
+  // finish up and garbage collections
+  PyObject *retval = Py_parse_args(ch, show_errors, cmd, parse_args, syntax);
+  free(parse_args);
+  return retval;
+}
+
+
 //
 // a wrapper around NakedMud's generic_find() function
 PyObject *mud_generic_find(PyObject *self, PyObject *args) {
@@ -201,8 +206,13 @@
     SET_BIT(type, FIND_TYPE_OBJ);
   if(is_keyword(type_str, "char", FALSE))
     SET_BIT(type, FIND_TYPE_CHAR);
+  if(is_keyword(type_str, "exit", FALSE))
+    SET_BIT(type, FIND_TYPE_EXIT);
   if(is_keyword(type_str, "in", FALSE))
     SET_BIT(type, FIND_TYPE_IN_OBJ);
+  if(is_keyword(type_str, "all", FALSE))
+    SET_BIT(type,FIND_TYPE_OBJ  | FIND_TYPE_CHAR | 
+	         FIND_TYPE_EXIT | FIND_TYPE_IN_OBJ);
 
   // do the search
   int found_type = FOUND_NONE;
@@ -215,6 +225,17 @@
     else
       return Py_BuildValue("Os", charGetPyFormBorrowed(found), "char");
   }
+  else if(found_type == FOUND_EXIT) {
+    // were we searching for one type, or multiple types?
+    PyObject   *exit = newPyExit(found);
+    PyObject *retval = NULL;
+    if(!strcasecmp("exit", type_str))
+      retval = Py_BuildValue("O", exit);
+    else
+      retval = Py_BuildValue("Os", exit, "obj");
+    Py_DECREF(exit);
+    return retval;
+  }
   else if(found_type == FOUND_OBJ) {
     // were we searching for one type, or multiple types?
     if(!strcasecmp("obj", type_str))
@@ -316,6 +337,8 @@
     SET_BIT(range, TO_VICT);
   if(is_keyword(pyrange, "to_room", FALSE))
     SET_BIT(range, TO_ROOM);
+  if(is_keyword(pyrange, "to_world", FALSE))
+    SET_BIT(range, TO_WORLD);
 
   // finally, send out the message
   message(ch, vict, obj, vobj, hide_nosee, range, mssg);
@@ -400,6 +423,46 @@
   return Py_BuildValue("i", ok);
 }
 
+//
+// returns the mud's message of the day
+PyObject *mud_get_motd(PyObject *self, PyObject *args) {
+  return Py_BuildValue("s", bufferString(motd));
+}
+
+PyObject *mud_log_string(PyObject *self, PyObject *args) {
+  char *mssg = NULL;
+  if(!PyArg_ParseTuple(args, "s", &mssg)) {
+    PyErr_Format(PyExc_TypeError, "a message must be supplied to log_string");
+    return NULL;
+  }
+
+  // we have to strip all %'s out of this message
+  BUFFER *buf = newBuffer(1);
+  bufferCat(buf, mssg);
+  bufferReplace(buf, "%", "%%", TRUE);
+  log_string(bufferString(buf));
+  deleteBuffer(buf);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mud_set_cmd_move(PyObject *self, PyObject *args) {
+  PyObject *cmd = NULL;
+  if(!PyArg_ParseTuple(args, "O", &cmd)) {
+    PyErr_Format(PyExc_TypeError, "a command must be suppled");
+    return NULL;
+  }
+
+  // make sure it's a function
+  if(!PyFunction_Check(cmd)) {
+    PyErr_Format(PyExc_TypeError, "a command must be suppled");
+    return NULL;
+  }
+
+  Py_XDECREF(py_cmd_move);
+  py_cmd_move = cmd;
+  return Py_BuildValue("i", 1);
+}
+
 
 
 //*****************************************************************************
@@ -428,8 +491,6 @@
 		  "Set the value of a global variable.");
   PyMud_addMethod("erase_global",  mud_erase_global, METH_VARARGS,
 		  "Erase the value of a global variable.");
-  PyMud_addMethod("add_cmd", mud_add_cmd, METH_VARARGS,
-		  "Add a new command to the game.");
   PyMud_addMethod("message", mud_message, METH_VARARGS,
 		  "plugs into the message() function from inform.h");
   PyMud_addMethod("format_string", mud_format_string, METH_VARARGS,
@@ -446,10 +507,22 @@
 		  "arguments (condition, if action) and an optional third "
 		  "(else action). If no else action is specified and the "
 		  "condition is false, None is returned.");
+  PyMud_addMethod("parse_args", mud_parse_args, METH_VARARGS,
+		  "equivalent to parse_args written in C");
+  PyMud_addMethod("get_motd", mud_get_motd, METH_VARARGS,
+		  "returns the mud's message of the day");
+  PyMud_addMethod("log_string", mud_log_string, METH_VARARGS,
+		  "adds a string to the mudlog");
+  PyMud_addMethod("set_cmd_move", mud_set_cmd_move, METH_VARARGS,
+		  "sets the movement command");
 
   Py_InitModule3("mud", makePyMethods(pymud_methods),
 		 "The mud module, for all MUD misc mud utils.");
 
   globals = PyDict_New();
   Py_INCREF(globals);
+}
+
+void *get_cmd_move(void) {
+  return py_cmd_move;
 }
diff -ruN ../nakedmudv3.1/src/scripts/pymud.h src/scripts/pymud.h
--- ../nakedmudv3.1/src/scripts/pymud.h	Sun Dec  4 20:03:07 2005
+++ src/scripts/pymud.h	Sat Jul  1 20:06:58 2006
@@ -22,4 +22,8 @@
 // new methods, see pymud.c
 void PyMud_addMethod(const char *name, void *f, int flags, const char *doc);
 
+//
+// returns the current defined cmd_move
+void *get_cmd_move(void);
+
 #endif //__PYMUD_H
